<template>
  <div>
    <div class="product-name">
      {{ product.name }} {{ productNameAndVariant }}
    </div>
    <div class="rating-5"></div>

    <div class="row-info">
      <div class="css-label">
        <p disabled>Harga</p>
      </div>
      <div class="css-value">
        <h3 v-if="variantByColorAndSize && variantByColorAndSize.price">
          Rp. {{ variantByColorAndSize.price | formatNumber }}
        </h3>
      </div>
    </div>
    <div class="row-info" v-if="product.colors && product.colors.length > 0">
      <div class="css-label">Warna</div>
      <div class="css-value">
        <p><b>Warna: </b> {{ selectColorLabel }}</p>
        <ul>
          <li v-for="color in product.colors" :key="color.id">
            <product-color :color="color"></product-color>
          </li>
        </ul>
      </div>
    </div>
    <div
      class="row-info"
      v-if="product && product.sizes && product.sizes.length > 0"
    >
      <div class="css-label">ukuran</div>
      <div class="css-value">
        <p><b>Ukuran: </b>{{ selectSizeLabel }}</p>
        <div
          class="size"
          :class="{ selected: size == selectedSize }"
          v-for="size in product.sizes"
          :key="size.id"
          @click="handleSelectSize(size)"
        >
          {{ size.name }}
        </div>
      </div>
    </div>
    <div class="row-info">
      <div class="css-label">
        <p disabled>Jumlah</p>
      </div>
      <div class="css-value">
        <p>
          <b>Jumlah: {{ qtyOrder }}</b>
        </p>
        <div class="qty-order">
          <div>
            <input type="number" v-model="qtyOrder" name="" id="" />
          </div>
          <div>
            {{ stockInfo }}
          </div>
        </div>
        <span style="color: red" v-show="qtyOrder > 1 && qtyOrder > stock"
          >Stok kurang dari jumlah yang di order</span
        >
        <span style="color: red" v-show="(qtyOrder == 1 && stock) == 0"
          >Stok HABIS</span
        >
      </div>
    </div>
    <div class="row-info">
      <div class="btn-action">
        <a class="btn info" @click="handleAddToCart()">{{ addToCartLabel }}</a>
        <a class="btn primary" style="margin-left: 10px">Beli Sekarang</a>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState } from "vuex";
export default {
  props: {
    product: {
      type: Object,
      default: null
    }
  },
  data() {
    return {
      stock: 0,
      qtyOrder: 1,
      stockInfo: "",
      variantByColorAndSize: {}
    };
  },
  methods: {
    handleSelectSize(size) {
      this.$store.commit("products/SET_SELECTED_SIZE", size);
    },
    checkProductVariants() {
      this.$store.dispatch("products/findProductVariants", {
        productId: this.product.id,
        colorId:
          this.selectedColor && this.selectedColor.id
            ? this.selectedColor.id
            : 0,
        sizeId:
          this.selectedSize && this.selectedSize.id ? this.selectedSize.id : 0
      });
    },
    handleAddToCart() {
      this.$store.dispatch("products/addProductToCart", this.product);
    }
  },
  computed: {
    ...mapState({
      selectedColor: state => state.products.selectedColor,
      selectedSize: state => state.products.selectedSize,
      selectedVariant: state => state.products.selectedVariant
    }),
    selectColorLabel() {
      return this.selectedColor.name ? this.selectedColor.name : "Pilih Warna";
    },
    selectSizeLabel() {
      return this.selectedSize && this.selectedSize.name
        ? this.selectedSize.name
        : this.selectedSize
        ? "Pilih Ukuran"
        : "";
    },
    productNameAndVariant() {
      let label =
        this.selectedColor && typeof this.selectedColor.name !== "undefined"
          ? " - " + this.selectedColor.name
          : "";
      label +=
        this.selectedSize && typeof this.selectedSize.name !== "undefined"
          ? "/" + this.selectedSize.name
          : "";
      return label;
    },
    addToCartLabel() {
      return typeof window !== "undefined" && window.innerWidth <= 815
        ? "+Keranjang"
        : "Tambah Keranjang";
    }
  },

  created() {
    setTimeout(() => {
      if (this.product.variants && this.product.variants.length > 0) {
        this.handleSelectSize(this.product.sizes[0]);
        this.$store.commit(
          "products/SET_SELECTED_COLOR",
          this.product.colors[0]
        );
      } else {
        this.variantByColorAndSize = {
          price: this.product.price,
          stock: this.product.stock
        };
      }
      this.stock = this.variantByColorAndSize.stock;
      this.stockInfo = "Stok: " + this.stock;
    }, 500);
  },
  watch: {
    selectedColor(val) {
      this.checkProductVariants();
    },
    selectedSize(val) {
      this.checkProductVariants();
    },
    selectedVariant(val) {
      if (val) {
        this.stock = val.stock;
        this.stockInfo = "Stok: " + (val.stock ? val.stock : "0");
        this.variantByColorAndSize = {
          price: val.price,
          stock: val.stock
        };
      } else {
        this.stockInfo = "Stok: Kosong";
        this.variantByColorAndSize = {
          price: this.product.price,
          stock: val.price
        };
      }
    }
  }
};
</script>
<style lang="scss" scoped>
ul {
  display: block;
  list-style-type: none;
  margin-block-start: 1em;
  margin-block-end: 1em;
  margin-inline-start: 0px;
  margin-inline-end: 0px;
  padding-inline-start: 40px;
}

ul li {
  position: relative;
  list-style: none;
  display: inline-block;
  vertical-align: top;
  margin: 0px;
}

.product-name {
  display: block;
  position: relative;
  font-weight: 800;
  text-decoration: initial;
  // font-size: 1.25rem;
  line-height: 1.3;
  color: rgba(49, 53, 59, 0.96);
}

.row-info {
  padding: 20px 0px;
  // border-top: 1px solid rgb(229, 231, 233);
  display: flex;
}

.row-info .center {
  text-align: center;
  align-items: center;
  justify-content: center;
}

.css-label {
  display: inline-block;
  text-transform: uppercase;
  vertical-align: top;
  width: 70px;
}
.css-value {
  display: inline-block;
  vertical-align: top;
  width: 624px;
  padding-left: 20px;
  margin: 0px;

  h3 {
    margin: 0px;
    color: rgb(250, 89, 29);
    font-size: 18px;
    text-align: center;
    vertical-align: middle;
  }
}
.btn-action {
  display: flex;
  justify-content: center;
  vertical-align: top;
  margin: 0px;
  flex: 1;
}
.size {
  min-width: 48px;
  border-radius: 16px;
  border: 1px solid rgb(229, 231, 233);
  color: rgba(49, 53, 59, 0.68);
  display: inline-flex;
  vertical-align: top;
  // flex: 1 1 0%;
  flex-wrap: nowrap;
  margin-bottom: 8px;
  margin-right: 8px;
  overflow: hidden;
  text-overflow: ellipsis;
  transition: all 0.28s ease-in-out 0s;
  cursor: pointer;
  min-width: 48px;
  height: 48px;
  padding: 3px 5px;
  font-size: 12px;
  white-space: normal;
  justify-content: center;
  align-items: center;
}

.selected {
  border: 1px solid rgb(79, 209, 90);
  color: rgb(3, 172, 14);
}

.buy-now-btn {
  color: rgb(250, 89, 29);
  font-family: "Nunito Sans", sans-serif;
  font-size: 1rem;
  height: 40px;
  line-height: 20px;
  width: auto;
  border-radius: 8px;
  font-weight: 800;
  outline: none;
  padding: 0px 16px;
  transition: background 0.8s ease 0s;
  cursor: pointer;
  background: radial-gradient(circle, transparent 1%, transparent 1%) center
    center / 15000% transparent;
  border: 1px solid rgb(250, 89, 29);
  text-indent: initial;
  position: relative;
  display: inline-block;
  vertical-align: middle;
  margin-left: 12px;
}

.add-to-chart-btn {
  color: rgb(255, 255, 255);
  font-family: "Nunito Sans", sans-serif;
  font-size: 1rem;
  height: 40px;
  line-height: 20px;
  width: auto;
  border-radius: 8px;
  font-weight: 800;
  outline: none;
  padding: 0px 16px;
  transition: background 0.8s ease 0s;
  cursor: pointer;
  background: radial-gradient(circle, transparent 1%, rgb(250, 89, 29) 1%)
    center center / 15000% rgb(250, 89, 29);
  border: none;
  text-indent: initial;
  position: relative;
  display: inline-block;
  vertical-align: middle;
  margin-left: 12px;
}

.qty-order {
  display: flex;
  align-items: center;
  justify-content: flex-start;
}

@media screen and (min-width: 601px) {
  .css-value b {
    display: none;
  }
}

@media screen and (max-width: 600px) {
  .css-value b {
    display: inline;
  }
  .css-label {
    display: none;
  }
  .product-image {
    flex-basis: 100%;
  }
  .row-info {
    padding: 10px 0px;
  }
  .qty-order {
    display: flex;
    align-items: center;
    justify-content: center;
  }
}
</style>
